<?php

	# 		U.K. - Climate
	# 		Namespace:		climateUK
	#		Meteotemplate Block
	
	# 		v1.0 - Jun 8, 2017
	# 			- initial release
		
	// load theme
	$designTheme = json_decode(file_get_contents("../../css/theme.txt"),true);
	$theme = $designTheme['theme'];
	
	include("../../../config.php");
	include("../../../css/design.php");
	include("../../../scripts/functions.php");

	$languageRaw = file_get_contents($baseURL."lang/gb.php");
	$language['gb'] = json_decode($languageRaw,true);
	$languageRaw = file_get_contents($baseURL."lang/".$lang.".php");
	$language[$lang] = json_decode($languageRaw,true);

	if(file_exists("settings.php")){
		include("settings.php");
	}
	else{
		echo "Please go to the Control Panel and go through the settings for this block first.";
		die();
	}

	$locationClimateUK = strtolower(trim($locationClimateUK));


	if($theme=="light"){
		$graphColor = $color_schemes[$design2]["900"];
	}
	else{
		$graphColor = "fff";
	}

	createCacheDir();

	$locationClimateUK = trim(strtolower($locationClimateUK));
	$locationClimateUK = str_replace(" ","",$locationClimateUK);
	$locationClimateUK = str_replace("-","",$locationClimateUK);

	if(file_exists("cache/data.txt")){
		if (time()-filemtime("cache/data.txt") > 60 * 60 * 24) {
			unlink("cache/data.txt");
		}
	}
	if(file_exists("cache/data.txt")){
		$dataRaw = file("cache/data.txt");
	}
	else {
		$dataURL = "http://www.metoffice.gov.uk/pub/data/weather/uk/climate/stationdata/".$locationClimateUK."data.txt";
		$dataRaw = loadContent($dataURL,5);
		file_put_contents("cache/data.txt",$dataRaw);
	}

	$dataRaw = file("cache/data.txt");

	$thisName = trim($dataRaw[0]);

	for($i=0;$i<count($dataRaw);$i++){
		$row = trim($dataRaw[$i]);
		$thisRow = preg_split('/\s+/', $row);
		if($thisRow[0]>1000){
			$Y = $thisRow[0];
			$M = $thisRow[1];
			$time = strtotime($Y."-".$M."-15");
			if($thisRow[2] != "---"){
				$val = str_replace("*","",$thisRow[2]);
				$val = str_replace("#","",$val);
				$data['Tmax'][] = array($time, $val);
			}
			if($thisRow[3] != "---"){
				$val = str_replace("*","",$thisRow[3]);
				$val = str_replace("#","",$val);
				$data['Tmin'][] = array($time, $val);
			}
			if($thisRow[4] != "---"){
				$val = str_replace("*","",$thisRow[4]);
				$val = str_replace("#","",$val);
				$data['F'][] = array($time, $val);
			}
			if($thisRow[5] != "---"){
				$val = str_replace("*","",$thisRow[5]);
				$val = str_replace("#","",$val);
				$data['R'][] = array($time, $val);
			}
			if($thisRow[6] != "---"){
				$val = str_replace("*","",$thisRow[6]);
				$val = str_replace("#","",$val);
				$data['S'][] = array($time, $val);
			}
		}
	}
?>
	<style>
		.climateUKSwitcher{
			cursor: pointer;
			opacity: 0.8;
			font-size: 1.6em;
		}
		.climateUKSwitcher:hover{
			opacity: 1;
		}
		.climateUKActive{
			color: #<?php echo $color_schemes[$design2]['500']?>;
		}
	</style>
	<table style="width:90%;margin: 0 auto">
		<tr>
			<td style="text-align:left;width:25%">
				<img src="<?php echo $pageURL.$path?>imgs/<?php echo $flagIconShape?>/big/gb.png" style="width:100%;max-width:60px">
			</td>
			<td style="text-align:center">
				<h2><?php echo $thisName?></h2>
			</td>
			<td style="text-align:right;width:25%">
				<img src="<?php echo $pageURL.$path?>imgs/climateImgs/outlines/gb.png" style="width:100%;max-width:80px">
			</td>
		</tr>
	</table>
	<div id="climateUKGraphT" style="width:98%;height:400px;margin:0 auto" class="climateUKGraph"></div>
	<input type="hidden" id="climateUKRRendered" value="0"><input type="hidden" id="climateUKSRendered" value="0">
	<div id="climateUKGraphR" style="width:98%;height:400px;margin:0 auto;display:none" class="climateUKGraph"></div>
	<div id="climateUKGraphS" style="width:98%;height:400px;margin:0 auto;display:none" class="climateUKGraph"></div>
	<div style="width:100%;text-align:center;padding-top:10px">
		<span class="mticon-temp climateUKSwitcher tooltip climateUKActive" title="<?php echo lang('temperature','c')?>" data-id="T"></span>
		<span class="mticon-rain climateUKSwitcher tooltip" title="<?php echo lang('precipitation','c')?>" data-id="R"></span>
		<span class="mticon-sun climateUKSwitcher tooltip" title="<?php echo lang('sunshine','c')?>" data-id="S"></span>
	</div>
	<div style="width:90%;margin:0 auto;font-size:0.8em;font-variant:small-caps;text-align:center">
		<?php echo lang('data source','c')?>: MetOffice
	</div>
	<script>
		Highcharts.setOptions({
			lang: {
				months: ['<?php echo lang('january','c')?>', '<?php echo lang('february','c')?>', '<?php echo lang('march','c')?>', '<?php echo lang('april','c')?>', '<?php echo lang('may','c')?>', '<?php echo lang('june','c')?>', '<?php echo lang('july','c')?>', '<?php echo lang('august','c')?>', '<?php echo lang('september','c')?>', '<?php echo lang('october','c')?>', '<?php echo lang('november','c')?>', '<?php echo lang('december','c')?>'],
				shortMonths: ['<?php echo lang('janAbbr','c')?>', '<?php echo lang('febAbbr','c')?>', '<?php echo lang('marAbbr','c')?>', '<?php echo lang('aprAbbr','c')?>', '<?php echo lang('mayAbbr','c')?>', '<?php echo lang('junAbbr','c')?>', '<?php echo lang('julAbbr','c')?>', '<?php echo lang('augAbbr','c')?>', '<?php echo lang('sepAbbr','c')?>', '<?php echo lang('octAbbr','c')?>', '<?php echo lang('novAbbr','c')?>', '<?php echo lang('decAbbr','c')?>'],
				weekdays: ['<?php echo lang('sundayAbbr','c')?>', '<?php echo lang('mondayAbbr','c')?>', '<?php echo lang('tuesdayAbbr','c')?>', '<?php echo lang('wednesdayAbbr','c')?>', '<?php echo lang('thursdayAbbr','c')?>', '<?php echo lang('fridayAbbr','c')?>', '<?php echo lang('saturdayAbbr','c')?>'],
				resetZoom: ['<?php echo lang('default zoom','c')?>']
			}		
		});
	</script>
	<?php 
		$graphHueColor = getColorHue("#".$color_schemes[$design2]["900"],"hex");
	?>
	<script>
		Highcharts.createElement('link', {
			href: 'http://fonts.googleapis.com/css?family=PT+Sans:400,700&subset=latin,cyrillic-ext,latin-ext',
			rel: 'stylesheet',
			type: 'text/css'
		}, null, document.getElementsByTagName('head')[0]);
		Highcharts.theme = {
			chart: {
				backgroundColor: null,
				color: "#<?php echo $color_schemes[$design]['font900']?>",
				style: {
					fontFamily: "'<?php echo $designFont?> Narrow', sans-serif"
				}
			},
			title: {
				style: {
					color: "#<?php echo $graphColor?>",
					//textTransform: 'uppercase',
					fontSize: '20px'
				}
			},
			subtitle: {
				style: {
					color: '#E0E0E3',
					textTransform: 'uppercase'
				}
			},
			xAxis: {
				gridLineColor: '#<?php echo $graphColor?>',
				labels: {
					style: {
						color: '#<?php echo $graphColor?>',
					}
				},
				lineColor: '#<?php echo $graphColor?>',
				minorGridLineColor: '#<?php echo $graphColor?>',
				tickColor: '#<?php echo $graphColor?>',
				title: {
					style: {
						color: '#<?php echo $graphColor?>',
					}
				}
			},
			yAxis: {
				gridLineColor: '#<?php echo $graphColor?>',
				gridLineWidth: 0,
				labels: {
					style: {
						color: '#<?php echo $graphColor?>',
					}
				},
				lineColor: '#<?php echo $graphColor?>',
				minorGridLineColor: '#<?php echo $graphColor?>',
				tickColor: '#<?php echo $graphColor?>',
				tickWidth: 1,
				title: {
					style: {
						color: '#<?php echo $graphColor?>',
					}
				}
			},
			tooltip: {
				backgroundColor: '#<?php echo $color_schemes[$design2]['900']?>',
				style: {
					color: '#<?php echo $color_schemes[$design2]['font900']?>'
				},
				xDateFormat: '%Y-%m',
				pointFormat: '{series.name}: <b>{point.y:.2f}</b><br/>'
			},
			plotOptions: {
				series: {
					dataLabels: {
						color: '#<?php echo $color_schemes[$design2]['900']?>'
					},
					marker: {
						lineColor: '#333'
					}
				}
			},
			legend: {
				itemStyle: {
					color: '#<?php echo $graphColor?>'
				},
				itemHoverStyle: {
					color: '#<?php echo $color_schemes[$design2]['500']?>'
				},
				itemHiddenStyle: {
					color: '#777777'
				},
			},
			credits: {
				style: {
					color: '#666'
				},
				text: '<?php echo $pageName." @ Meteotemplate"?>',
				href: '<?php echo $pageURL.$path?>'
			},
			labels: {
				style: {
					color: '#707073'
				}
			},
		};

		// Apply the theme
		Highcharts.setOptions(Highcharts.theme);
			
		optionsT = 	{
			chart: {
				zoomType: 'x'
			},
			title: {
				text: "",
				useHTML: true
			},
			yAxis:[
				{
					title: {
						text: '°C'
					}
				}
			],
			xAxis:{
				type: 'datetime',
			},
			tooltip: {
				shared: true
			},
			plotOptions: {
			},
			series: [
				<?php 
					if(isset($data['Tmax'])){
				?>
						{
							type: "spline",
							name: "<?php echo lang('maximumAbbr','c')." ".lang('temperature','l')?> 1981-2010",
							data: [
								<?php
							 		for($i=0;$i<count($data['Tmax']);$i++){
										echo "[".($data['Tmax'][$i][0] * 1000).",".$data['Tmax'][$i][1]."],";
									}
								?>
							],
							yAxis: 0,
							color: "<?php echo $theme=='dark' ? '#ff5e5e' : '#af0000'?>",
							zIndex: 4,
						},
				<?php 
					}
				?>
				<?php 
					if(isset($data['Tmin'])){
				?>
						{
							type: "spline",
							name: "<?php echo lang('minimumAbbr','c')." ".lang('temperature','l')?>",
							data: [
								<?php
							 		for($i=0;$i<count($data['Tmin']);$i++){
										echo "[".($data['Tmin'][$i][0] * 1000).",".$data['Tmin'][$i][1]."],";
									}
								?>
							],
							yAxis: 0,
							color: "<?php echo $theme=='dark' ? '#7b9ffc' : '#001f70'?>",
							zIndex: 4,
						},
				<?php 
					}
				?>
			]
		};
		optionsR = 	{
			chart: {
				zoomType: 'x'
			},
			title: {
				text: "",
				useHTML: true
			},
			yAxis:[
				{
					title: {
						text: 'mm'
					}
				}
			],
			xAxis:{
				type: 'datetime',
				tickInterval: 1
			},
			tooltip: {
				shared: true
			},
			plotOptions: {
			},
			series: [
				<?php 
					if(isset($data['R'])){
				?>
						{
							type: "areaspline",
							name: "<?php echo lang('precipitation','c')?>",
							data: [
								<?php
							 		for($i=0;$i<count($data['R']);$i++){
										echo "[".($data['R'][$i][0] * 1000).",".number_format($data['R'][$i][1],1,".","")."],";
									}
								?>
							],
							yAxis: 0,
							color: "<?php echo $theme=='dark' ? '#7b9ffc' : '#001f70'?>",
							zIndex: 4,
							dataGrouping: {
								approximation: "sum"
							}
						},
				<?php 
					}
				?>
			]
		};
		optionsS = 	{
			chart: {
				zoomType: 'x'
			},
			title: {
				text: "",
				useHTML: true
			},
			yAxis:[
				{
					title: {
						text: '<?php echo lang('hAbbr','l')?>'
					}
				}
			],
			xAxis:{
				type: 'datetime',
				tickInterval: 1
			},
			tooltip: {
				shared: true
			},
			plotOptions: {
			},
			series: [
				<?php 
					if(isset($data['S'])){
				?>
						{
							type: "areaspline",
							name: "<?php echo lang('sunshine','c')?>",
							data: [
								<?php
							 		for($i=0;$i<count($data['S']);$i++){
										echo "[".($data['S'][$i][0] * 1000).",".number_format($data['S'][$i][1],1,".","")."],";
									}
								?>
							],
							yAxis: 0,
							color: "#f4e542",
							zIndex: 4,
							dataGrouping: {
								approximation: "sum"
							}
						},
				<?php 
					}
				?>
			]
		};
		Highcharts.stockChart('climateUKGraphT', optionsT);
		$(".climateUKSwitcher").click(function(){
			id = $(this).attr("data-id");
			$(".climateUKGraph").hide();
			$("#climateUKGraph" + id).show();
			$(".climateUKSwitcher").removeClass("climateUKActive");
			$(this).addClass("climateUKActive");
			if(id=="R"){
				renderedR = $("#climateUKRRendered").val();
				if(renderedR == 0){
					Highcharts.stockChart('climateUKGraphR', optionsR);
					$("#climateUKRRendered").val(1)
				}
			}
			if(id=="S"){
				renderedS = $("#climateUKSRendered").val();
				if(renderedS == 0){
					Highcharts.stockChart('climateUKGraphS', optionsS);
					$("#climateUKSRendered").val(1)
				}
			}
		})
	</script>
	
